/**
 * @author Michael Legere
 * @version 2.0
 * @date March 18th, 2011
 */



import greenfoot.*;  // (Actor, World, Greenfoot, GreenfootImage)
import javax.swing.JOptionPane;
import java.util.List;
public class CrabWorld extends World
{
    int health = 50;
    int helpersLeft = 0;  //The blue lobsters
    int spidersEaten = 0; //Self explanatory
    private int lvl = 1; //Start at level 1
    int score = 0; // Does this need a comment? (No I'm bored)
    /**
     * Create the crab world. The world has a size 
     * of 560x560 cells, where every cell is just 1 pixel.
     */
    public CrabWorld() 
    {
        /**
         * Begin at level 1, puts the below objects into the world
         * at the start. (The energy bar, the score counter, 
         * the lobster(you), and a crab)
         */
        super(560, 560, 1);
        addObject(new Crab(), getWidth()/2, getHeight()/2);
        addObject(new Lobster(), 30, 530);
        addObject(new Score(score), 300, 15);
        addObject(new EnergyBar(), 550, 45);
        addObject(new Health(health), 400, 15);
    }
    public void act()
    {
        List listCrabs = getObjects(Crab.class);
         /**
          * You can play as long as the amount
          * of crabs is less than twice the starting
          * number of Crabs.(Not including level 1)
          */
        
        if(lvl != 21)
        {
            if(listCrabs.size() < (lvl) * 2)
            {
                if (lvl < 5)
                {
                     /**
                     * Level up here. Add 1000 to score, add the NxtLevel message, 
                     * raise the level, and repopulate. Only works if 3 objects are left:
                     * You, the scoreboard, and the energy bar.
                     */
                    if (numberOfObjects() == 4)
                    {
                         score += 1000;
                         addObject(new NxtLevel(), getWidth()/2, getHeight()/2);
                         lvl += 1;
                        if(lvl == 5) // You get a buddy! (because it's level 5)
                        {
                            addObject(new Buddy(), getWidth()/2, getHeight()/2);
                        }
                        
                         populate();
                    }
                 }
                if (lvl >= 5) //The fun stuff is level 5 and up.
                {
                     /**
                     * If you eat 5 spiders, you get 5 helpers to summon.
                     */
                     if (spidersEaten == 5)
                     {
                        spidersEaten = 0;
                        helpersLeft = 2;
                     }
                     if (Greenfoot.isKeyDown("m") && helpersLeft > 0) //Send out the helper lobsters
                     {
                         addObject(new Killer(), getWidth()/2, getHeight()/2); // put them in the middle of the screen
                         helpersLeft -= 1;
                     }
                     /**
                      * Level up here. Add 1000 to score, add the NxtLevel message, 
                      * raise the level, and repopulate. Only works if 4 objects are left:
                      * You, your buddy, the scoreboard, and the energy bar.
                      */
                     if (numberOfObjects() == 5)
                     {
                         score += 1000;
                         addObject(new NxtLevel(), getWidth()/2, getHeight()/2);
                         lvl += 1;
                        
                        if(lvl == 20)
                        {
                            addObject(new Boss(), getWidth()/2, 500);
                            List player = getObjects(Lobster.class);
                            removeObjects(player);
                            addObject(new Lobster(), 25, 25);
                        }
                        
                        populate();
                     }
                }
        }
        /**
         * If the Crab population doubles remove the lobsters and throw out a 
         * JPane message saying you've lost, as long as it's not level 1 or 2.
         */
        else if(listCrabs.size() >= (lvl) * 2 && lvl != 1 && lvl != 2) 
        {
            List listLobster = getObjects(Lobster.class);
            List listBuddies = getObjects(Buddy.class);
            removeObjects(listBuddies);
            removeObjects(listLobster);
            JOptionPane.showMessageDialog(null, "Overpopulation led to your extinction!");
            Greenfoot.stop();
        }
        /**
         * I made it so that on lvl 1 and 2 you can still play if the crabs double in population,
         * if I hadn't it would've been kinda cheap. So there can be (lvl+1)*2 crabs before the
         * message appears.
         */
        else if(listCrabs.size() >= (lvl+1) * 2 && lvl <= 2) //if its level one or two, allow for more than double crabs
        {                                                  
            List listLobster = getObjects(Lobster.class);  
            List listBuddies = getObjects(Buddy.class);
            List k = getObjects(NxtLevel.class);
            removeObjects(k);
            removeObjects(listBuddies);
            removeObjects(listLobster);
            JOptionPane.showMessageDialog(null, "Overpopulation led to your extinction!");
            Greenfoot.stop();
        }
    }
    else
    {
         List listCrab = getObjects(Crab.class);
         removeObjects(listCrab);
         JOptionPane.showMessageDialog(null, "You've successfully protected your tidal pool!");
         Greenfoot.stop();
    }
    }
    public void populate()
    {
        for (int i = lvl ; i > 0 ; i--)
        {
            int x = Greenfoot.getRandomNumber(560); //random x-coordinate for Crab (or Spider)
            int y = Greenfoot.getRandomNumber(560); //random y-coordinate for Crab (or Spider)
            int z = Greenfoot.getRandomNumber(10); 
            /** 
             * This if statement determines if a Spider gets put in the world this level
             */
            if(z == 9 && lvl%2 == 0) //Spiders only come in on even levels
            {
                addObject(new Spider(), y, x);
            }
            addObject(new Crab(), x, y);
        }
    }
}
